// ML1 - multilot clone based on sma filter
// author - fryk@tlen.pl, 2006

#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+
extern double Lots = 0.1;
extern double StopLoss = 40.0;
extern double TakeProfit = 13.00;
extern double LotIncreaseFactor = 0.21;//Added by Aaragorn 9-11-06 to increase lots based on account free margin
//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double MaxTrades = 5;
extern double Pips = 3;
extern double AccountProtection = 1;
extern double mm = 0;
extern double risk = 0.15;
extern double AccountisNormal = 0;
extern int mP = 28;
extern int mI = 1;
extern double mL = 1.85;

//+------------------------------------------------------------------+
//| Global variables                                               |
//+------------------------------------------------------------------+
double OpenOrders = 0;
int cnt = 0;
double slippage = 5;
double sl = 0;
double tp = 0;
double BuyPrice = 0;
double SellPrice = 0;
double lotsi = 0;
double mylotsi = 0;
double mode = 0;
double MyOrderType=0;
bool ContinueOpening = True;
double LastPrice = 0;
double PreviousOpenOrders = 0;
double Profit = 0;
double LastTicket = 0;
double LastType = 0;
double LastClosePrice = 0;
double LastLots = 0;



int start()
{
   if( mm != 0 ) lotsi = NormalizeDouble( (AccountFreeMargin() / 50.0) * (risk/100.0), 2); else lotsi = Lots;

if ( lotsi < 0.01 ) lotsi = 0.01;
if( lotsi > 100 ) lotsi = 100;

OpenOrders = 0;
for( cnt = 0; cnt < OrdersTotal(); cnt++ ) {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol() ==  Symbol() ) OpenOrders++;
}
 
// candle pattern recongitions
//Define Variables
double C1= iClose(NULL,0,1);//most recent complete bar
double C2= iClose(NULL,0,2);//most recent complete bar -1
double C3= iClose(NULL,0,3);//most recent complete bar -2
double C4= iClose(NULL,0,4);//most recent complete bar -3
double C5= iClose(NULL,0,5);//most recent complete bar -4
double C6= iClose(NULL,0,6);//most recent complete bar -5
double C7= iClose(NULL,0,7);//most recent complete bar -6
double C8= iClose(NULL,0,8);//most recent complete bar -7
double C9= iClose(NULL,0,9);//most recent complete bar -8
double O1= iOpen(NULL,0,1);//most recent complete bar
double O2= iOpen(NULL,0,2);//most recent complete bar -1
double O3= iOpen(NULL,0,3);//most recent complete bar -2
double O4= iOpen(NULL,0,4);//most recent complete bar -3
double O5= iOpen(NULL,0,5);//most recent complete bar -4
double O6= iOpen(NULL,0,6);//most recent complete bar -5
double O7= iOpen(NULL,0,7);//most recent complete bar -6
double O8= iOpen(NULL,0,8);//most recent complete bar -7
double O9= iOpen(NULL,0,9);//most recent complete bar -8
double H1= iHigh(NULL,0,1);//most recent complete bar 
double H2= iHigh(NULL,0,2);//most recent complete bar -1
double H3= iHigh(NULL,0,3);//most recent complete bar -2
double H4= iHigh(NULL,0,4);//most recent complete bar -3
double H5= iHigh(NULL,0,5);//most recent complete bar -4
double H6= iHigh(NULL,0,6);//most recent complete bar -5
double L1= iLow(NULL,0,1);//most recent complete bar 
double L2= iLow(NULL,0,2);//most recent complete bar -1
double L3= iLow(NULL,0,3);//most recent complete bar -2
double L4= iLow(NULL,0,4);//most recent complete bar -3
double L5= iLow(NULL,0,5);//most recent complete bar -4
double L6= iLow(NULL,0,6);//most recent complete bar -5
bool Hangingman = False;
      
//if (C5<C4<=C3 && ((L3<=O2 && H2==C2 && (H2-O2)*2<=(O2-L2) && C1<O2) || (L3<=C2 && H2==O2 && (H2-C2)*2<=(C2-L2) && C1<C2)) ) Hangingman = True;//Hanging Man, Bearish Signal
if( AccountEquity() > AccountBalance()+(AccountBalance()*0.1) ) Hangingman = True;
if(Hangingman && OpenOrders > 2) { 
   for( cnt = OrdersTotal()-1; cnt >= 0; cnt-- ) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      mode = OrderType();
      if( OrderSymbol() == Symbol() ) {
         if( mode ==  OP_BUY )  OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue);
         if( mode ==  OP_SELL ) OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red);
         Sleep(20);
      }
   }
   Hangingman=False;
}
//end of candle enhanced closing code

      
if( PreviousOpenOrders > OpenOrders ) {
   for( cnt = OrdersTotal()-1; cnt >= 0; cnt-- ) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      mode = OrderType();
      if( OrderSymbol() == Symbol() ) {
         if( mode ==  OP_BUY )  OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue);
         if( mode ==  OP_SELL ) OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red);
         Sleep(20);
      }
   }
   OpenOrders=0;
}

PreviousOpenOrders = OpenOrders;
if( OpenOrders >= MaxTrades ) ContinueOpening = False ; else ContinueOpening = True;

double ma1=iMA(NULL,PERIOD_M15,mP,0,0,5,0+mI);
double ma2=iMA(NULL,PERIOD_M15,mP,0,0,5,1+mI);
bool NewOrder=false;

if ( MathAbs(ma1-ma2)/Point > mL )
{
   NewOrder = true;
}

if( OpenOrders < 1 ) MyOrderType=0;
if( OpenOrders < 1 && NewOrder == true && ma1 < ma2 ) {
   LastPrice = 0;
   MyOrderType=1;
}
if( OpenOrders < 1 && NewOrder == true && ma1 > ma2 ) {
   LastPrice = 0;
   MyOrderType=2;
}

LastTicket = 0;
LastType = 0;
LastClosePrice = 0;
LastLots = 0;

for( cnt = 0; cnt < OrdersTotal(); cnt++ ) {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol() == Symbol() ) {
         LastPrice = OrderOpenPrice();
         if(OrderType()==OP_BUY)  MyOrderType=2;
         if(OrderType()==OP_SELL)  MyOrderType=1;

      LastTicket = OrderTicket();
      if( OrderType() ==  OP_BUY ) LastType = 0;
      if( OrderType() ==  OP_SELL ) LastType = 1;
      LastClosePrice = OrderClosePrice();
      LastLots = OrderLots();
   }
}

if( MyOrderType == 1 && ContinueOpening ) {
   if( Bid - LastPrice >= Pips * Point || OpenOrders < 1 ) {
      SellPrice = Bid;
      LastPrice = 0;
      if( TakeProfit ==  0 ) tp = 0 ; else tp = SellPrice - TakeProfit * Point;
      if( StopLoss ==  0 ) sl = 0 ; else sl = SellPrice + StopLoss * Point;
      if( OpenOrders != 0 ) {
         mylotsi = lotsi;
         for(cnt =0;cnt <OpenOrders;cnt ++) {
            if( MaxTrades > 12 ) mylotsi = NormalizeDouble(mylotsi * 1.5,2) ; else mylotsi = NormalizeDouble(mylotsi * 2,2);
         }
      }
      else {
         mylotsi = lotsi;
      }
/// //Added by Aaragorn 9-18-06 to increase lots based on account free margin     
if(OpenOrders == 0)
{
mylotsi = 0.01;
}
if(OpenOrders == 2)
{
LotIncreaseFactor = 1;
mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
}
if(OpenOrders == 3)
{
LotIncreaseFactor = 1.6;
mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
}
///
      if( mylotsi > 100 ) mylotsi = 100;
      OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"",0,0,Red);
      return(0);
   }
}

if( MyOrderType == 2 && ContinueOpening ) {
   if( LastPrice - Ask >= Pips * Point || OpenOrders < 1 ) {
      BuyPrice = Ask;
      LastPrice = 0;
      if( TakeProfit ==  0 ) tp = 0 ; else tp = BuyPrice + TakeProfit * Point;
      if( StopLoss ==  0 ) sl = 0 ; else sl = BuyPrice - StopLoss * Point;
      if( OpenOrders != 0 ) {
         mylotsi = lotsi;
         for(cnt =0;cnt <OpenOrders;cnt ++) {
            if( MaxTrades > 12 ) mylotsi = NormalizeDouble(mylotsi * 1.5,2) ; else mylotsi = NormalizeDouble(mylotsi * 2,2);
         }
      }
      else {
         mylotsi = lotsi;
      }
//// //Added by Aaragorn 9-18-06 to increase lots based on account free margin     
if(OpenOrders == 0)
{
mylotsi = 0.01;
}
if(OpenOrders == 2)
{
LotIncreaseFactor = 1;
mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
}
if(OpenOrders == 3)
{
LotIncreaseFactor = 1.6;
mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
}
////      
      if( mylotsi > 100 ) mylotsi = 100;
      OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"",0,0,Blue);
      return(0);
   }
}

return(0);
}